ScrollWindow = {}
ScrollWindow.__index = ScrollWindow

setmetatable( ScrollWindow, {
	__call = function( class, name, parent, contextId, childCount )
		local self = setmetatable( {}, ScrollWindow )
		
		if ( not self:Initialize(name, parent, contextId) ) then
			do return nil end
		end
		
		return self
	end,
})

function ScrollWindow:Initialize(name, parent, contextId, childCount)
	if ( name == nil or name == "" or parent == nil 
			or not self.Controls:Initialize(name, parent, contextId, childCount) ) then
		do return false end
	end
	
	return true
end

function ScrollWindow:ClearAnchors()
	self.Controls.mainControl:ClearAnchors()
end

function ScrollWindow:GetAnchor(anchorId)
	anchorId = anchorId or 0
	return self.Controls.mainControl:GetAnchor(anchorId)
end

function ScrollWindow:IsHidden()
	return self.Controls.mainControl:IsHidden()
end

function ScrollWindow:SetAnchor(point, relativeTo, relativePoint, offsetX, offsetY)
	self.Controls.mainControl:SetAnchor(point, relativeTo, relativePoint, offsetX, offsetY)
end

function ScrollWindow:SetHidden(hidden, force)
	if ( not hidden and ( force or #self.Controls.scrollControl.dataEntry.data ) ) then
		self.Controls:Show()
	else
		self.Controls:Hide()
	end
end

function ScrollWindow:SetRow(value)
	self.Controls.currentRow = value
	if ( not self.Controls.mainControl:IsHidden() ) then
		self.Controls:RefreshScrollList()
	end
end

function ScrollWindow:SetRowDimensions(width, height)
	self.Controls:SetRowDimensions(width, height)
end

function ScrollWindow:SetRowPadding(value)
	if ( type(value) == "number" ) then
		self.Controls.scrollControl.dataEntry.rowPadding = value
	end
end

function ScrollWindow:SetSliderWidth(width)
	if ( type(width) == "number" ) then
		self.Controls.sliderControl:SetWidth(width)
	end
end